// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	"fmt"
	smithy "github.com/aws/smithy-go"
)

// The requested report expired. Update the date interval and try again.
type BillExpirationException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *BillExpirationException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *BillExpirationException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *BillExpirationException) ErrorCode() string             { return "BillExpirationException" }
func (e *BillExpirationException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The requested data is unavailable.
type DataUnavailableException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *DataUnavailableException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *DataUnavailableException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *DataUnavailableException) ErrorCode() string             { return "DataUnavailableException" }
func (e *DataUnavailableException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The pagination token is invalid. Try again without a pagination token.
type InvalidNextTokenException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *InvalidNextTokenException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidNextTokenException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidNextTokenException) ErrorCode() string             { return "InvalidNextTokenException" }
func (e *InvalidNextTokenException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// You made too many calls in a short period of time. Try again later.
type LimitExceededException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *LimitExceededException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *LimitExceededException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *LimitExceededException) ErrorCode() string             { return "LimitExceededException" }
func (e *LimitExceededException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Your request parameters changed between pages. Try again with the old parameters
// or without a pagination token.
type RequestChangedException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *RequestChangedException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *RequestChangedException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *RequestChangedException) ErrorCode() string             { return "RequestChangedException" }
func (e *RequestChangedException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified ARN in the request doesn't exist.
type ResourceNotFoundException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *ResourceNotFoundException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ResourceNotFoundException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ResourceNotFoundException) ErrorCode() string             { return "ResourceNotFoundException" }
func (e *ResourceNotFoundException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// You've reached the limit on the number of resources you can create, or exceeded
// the size of an individual resource.
type ServiceQuotaExceededException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *ServiceQuotaExceededException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ServiceQuotaExceededException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ServiceQuotaExceededException) ErrorCode() string             { return "ServiceQuotaExceededException" }
func (e *ServiceQuotaExceededException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The cost anomaly monitor does not exist for the account.
type UnknownMonitorException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *UnknownMonitorException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UnknownMonitorException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UnknownMonitorException) ErrorCode() string             { return "UnknownMonitorException" }
func (e *UnknownMonitorException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The cost anomaly subscription does not exist for the account.
type UnknownSubscriptionException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *UnknownSubscriptionException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UnknownSubscriptionException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UnknownSubscriptionException) ErrorCode() string             { return "UnknownSubscriptionException" }
func (e *UnknownSubscriptionException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Cost Explorer was unable to identify the usage unit. Provide
// UsageType/UsageTypeGroup filter selections that contain matching units, for
// example: hours.
type UnresolvableUsageUnitException struct {
	Message *string

	noSmithyDocumentSerde
}

func (e *UnresolvableUsageUnitException) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UnresolvableUsageUnitException) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UnresolvableUsageUnitException) ErrorCode() string             { return "UnresolvableUsageUnitException" }
func (e *UnresolvableUsageUnitException) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }
