// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	smithydocument "github.com/aws/smithy-go/document"
	"time"
)

// Information required for edge device metrics.
type EdgeMetric struct {

	// The dimension of metrics published.
	Dimension *string

	// Returns the name of the metric.
	MetricName *string

	// Timestamp of when the metric was requested.
	Timestamp *time.Time

	// Returns the value of the metric.
	Value float64

	noSmithyDocumentSerde
}

// Information about a model deployed on an edge device that is registered with
// SageMaker Edge Manager.
type Model struct {

	// The timestamp of the last inference that was made.
	LatestInference *time.Time

	// The timestamp of the last data sample taken.
	LatestSampleTime *time.Time

	// Information required for model metrics.
	ModelMetrics []EdgeMetric

	// The name of the model.
	ModelName *string

	// The version of the model.
	ModelVersion *string

	noSmithyDocumentSerde
}

type noSmithyDocumentSerde = smithydocument.NoSerde
